import type { Readable } from 'svelte/store';
import type { FullDataTableConfig } from '../types/DataTableConfig.js';
import type { PaginatedListRequest } from '../types/PaginatedListRequest.js';
import type { IDataSource } from './IDataSource.js';
import type { QueryObserver } from './QueryObserver.js';
export declare abstract class AbstractDataSource<Data> implements IDataSource<Data> {
    private currentStatus;
    private queryObserver;
    private setQueryStatus;
    protected dataTableConfig: FullDataTableConfig<Data>;
    init(config: FullDataTableConfig<Data>): void;
    getQueryObserver(): Readable<QueryObserver<Data>>;
    protected updateStatus(status: Pick<QueryObserver<Data>, 'data'> | Pick<QueryObserver<Data>, 'error'>): void;
    abstract requestData(data: PaginatedListRequest<Data>): void;
}
