import { writable } from 'svelte/store';
import { hasOwnProperty } from '../util/generalUtil.js';
import { buildLoadingQueryObserver } from './QueryObserver.js';
export class AbstractDataSource {
    currentStatus = buildLoadingQueryObserver();
    queryObserver = writable(this.currentStatus, (set) => {
        set(this.currentStatus);
        this.setQueryStatus = set;
        return () => (this.setQueryStatus = undefined);
    });
    setQueryStatus;
    dataTableConfig;
    init(config) {
        this.dataTableConfig = config;
    }
    getQueryObserver() {
        return this.queryObserver;
    }
    updateStatus(status) {
        const hasData = hasOwnProperty(status, 'data') && !!status.data;
        const hasError = hasOwnProperty(status, 'error') && !!status.error;
        this.currentStatus = {
            isError: hasError,
            isLoading: !hasData && !hasError,
            isSuccess: hasData && !hasError,
            data: undefined,
            error: undefined,
            ...status
        };
        this.setQueryStatus && this.setQueryStatus(this.currentStatus);
    }
}
