import type { ParsedSearchQuery } from './ParsedSearchQuery.js';
import type { SearchFilter } from '../types/SearchFilter.js';
import { AbstractSearchParser } from './AbstractSearchParser.js';
export declare type QueryPartParser<SearchCategory extends string = string, SearchFilterType extends string = string> = (queryPart: string) => {
    searchCategory?: SearchCategory;
    searchFilter?: SearchFilter<SearchFilterType>;
} | false;
export declare type AliasMap<T extends string = string> = Record<T, string[]>;
export declare class AdvancedSearchParser<SearchCategory extends string = string, SearchFilterType extends string = string> extends AbstractSearchParser<SearchCategory, SearchFilterType> {
    private readonly searchCategoryAliases;
    private readonly searchFilterAliases;
    private readonly additionalQueryPartParsers;
    constructor(options?: {
        searchCategoryAliases?: AliasMap<SearchCategory>;
        searchFilterAliases?: AliasMap;
        additionalQueryPartParsers: QueryPartParser<SearchCategory, SearchFilterType>[];
    });
    parseSearchQuery(rawSearchQuery: string): ParsedSearchQuery<SearchCategory, SearchFilterType> | undefined;
    private matchPartialAlias;
}
